      SUBROUTINE EXT_AIRSBT(KNBMESS,KNBMECR,CDTYPM,KNBWAG,
     &                      PLATN,PLATS,PLONO,PLONE,KPLEIN)
!-----------------------------------------------------------------------
!  auteur de revision : F. Guillaume
!  date de revision   : 17/03/2008
!  objet              : formats explicites d'ecriture dans OBSOUL
!                       pour mise en conofmite SOPRANO.
!=======================================================================

      IMPLICIT LOGICAL(L)

#include "oulan_pardimo.h"
#include "oulan_yomtomv.h"
#include "oulan_yompin.h"
#include "oulan_yomdirs.h"
#include "oulan_yomnbob.h"
#include "oulan_yomdate.h"
#include "oulan_yomcsts.h"

      PARAMETER ( JP_NBX_PAR_3 = 10     , JP_DIM_STRUCT = 1476  )

      CHARACTER  CLLAT            *  12 , CLLON                  *   12
      CHARACTER  CDTYPM           *  10
      CHARACTER  CL_NULL          *   5

      CHARACTER  CL_TYPE_MESS     *  20 , CL_VERS_MESS           *   20
      CHARACTER  CL_MIN_DATE      *  14 , CL_MAX_DATE            *   14
      CHARACTER  CL_LAST_ARRIVED  *   1 , CL_LISTE_PARAM(1)      *   15
      CHARACTER  CL_LISTE_STAT(1) *   4 , CL_DONNEES(5,KNBMESS)  *   80
      CHARACTER  CL_AUTORISATION  *  30
      INTEGER    I_PAS_DE_TPS , I_NB_PARAM , I_TYPE_SORTIE , I_NBRE_STAT
      INTEGER    I_CODE_RETOUR_EXT , I_NB_MESS
      REAL       Z_DONNEES(JP_DIM_STRUCT,KNBMESS)

      REAL  DL_MIN_LAT , DL_MAX_LAT
      REAL  DL_MIN_LON , DL_MAX_LON

      CHARACTER CLINDIC*12,CLSATOUT(10)*3,CLNBSATOUT(10)*6
      CHARACTER CLSATECH(10)*3,CLNBSATECH(10)*6,CLPROD*9,CLSOUL*9
      INTEGER   INBSATOUT(10),INBSATECH(10)
      INTEGER   ICODM(KNBMESS)
      INTEGER   INOSAT(30),INBSAT(30),ID_NOAA_20

!      INTEGER   IVNM_1(JP_NBX_PAR_1),IFLG_1(JP_NBX_PAR_1)
!      REAL      ZPOB_1(JP_NBX_PAR_1),ZPRL_1(JP_NBX_PAR_1)
!      REAL      ZVAR_1(JP_NBX_PAR_1)
!      INTEGER   IVNM_2(JP_NBX_PAR_2),IFLG_2(JP_NBX_PAR_2)
!      REAL      ZPOB_2(JP_NBX_PAR_2),ZPRL_2(JP_NBX_PAR_2)
!      REAL      ZVAR_2(JP_NBX_PAR_2)
      INTEGER   IVNM_3(JP_NBX_PAR_3),IFLG_3(JP_NBX_PAR_3)
      REAL      ZPOB_3(JP_NBX_PAR_3),ZPRL_3(JP_NBX_PAR_3)
      REAL      ZVAR_3(JP_NBX_PAR_3)

! ----------------------------------------------------------------------
! code pour realiser des sorties formatees  OBSOUL (SOPRANO)

      character entete * 84, wagon_prov * 34
      character wagon  * 34, fmt_final * 117
! ----------------------------------------------------------------------


#include "oulan_yombitu.h"

! ----------------------------------------------------------------------
! code pour realiser des sorties formatees  OBSOUL (SOPRANO)

      entete = "(I4,1X,I2,1X,I9,1X,F9.5,1X,F10.5,1X,A12,1X,I8,1X,I6,1X"
      entete = trim(adjustl(entete)) // ",ES12.5,1X,I5,1X,I7,1X,I7,1X,"
      wagon_prov = "(I5,'(1X,I3,1X,3(ES12.5,1X),I11)')"                       
! ----------------------------------------------------------------------

      CL_NULL      = 'NULL'//CHAR(0)

      ID_NOAA_20   = 222
      IZERO        = 0
      ICQUN        = 1
      INUMST       = 0
      INBEXTOT     = 0
      INBRETOT     = 0
      INOSAT       = 0
      INBSAT       = 0
      CLNBSATOUT   = '      '
      CLSATOUT     = '   '
      INBSATOUT    = 0
      I_NB_SAT_OUT = 0

      KNBMECR      = 0
      KPLEIN       = 0

!-----------------------------------------------------------------------

!  Initialisations des arguments de la fonction d'extraction
!  ---------------------------------------------------------

      CL_TYPE_MESS( 1:10) = CDTYPM
      CL_TYPE_MESS(11:20) = '          '
      CL_VERS_MESS        = '%                   '
      CL_MIN_DATE         = CDATDEB(2)
      CL_MAX_DATE         = CDATFIN(2)
      CL_AUTORISATION     = 'OPER                          '
      CL_LAST_ARRIVED     = 'Y'
      CL_LISTE_STAT(1)    = 'NULL'
      CL_LISTE_PARAM(1)   = 'NULL           '

      I_PAS_DE_TPS        = 0
      I_NB_PARAM          = 0
      I_TYPE_SORTIE       = 3
      I_NBRE_STAT         = 0
      I_NB_MESS           = KNBMESS

      DL_MIN_LAT          = PLATS
      DL_MAX_LAT          = PLATN
      DL_MIN_LON          = PLONO
      DL_MAX_LON          = PLONE

      CL_DONNEES          = ' '
      Z_DONNEES           = RABSI

!-----------------------------------------------------------------------

!  Extraction
!  ----------

      PRINT *,' '
      PRINT *,' Extraction des ',CDTYPM
      PRINT *,' '

      CALL RDLLTDOMAINDECOD( CL_TYPE_MESS , CL_VERS_MESS , CL_MIN_DATE ,
     &                       CL_MAX_DATE , CL_AUTORISATION ,
     &                       CL_LAST_ARRIVED , I_PAS_DE_TPS ,
     &                       CL_NULL , I_NB_PARAM , Z_DONNEES ,
     &                       CL_DONNEES , CL_NULL , I_TYPE_SORTIE ,
     &                       I_NB_MESS , DL_MIN_LAT , DL_MAX_LAT ,
     &                       DL_MIN_LON , DL_MAX_LON , CL_NULL ,
     &                       I_NBRE_STAT , I_CODE_RETOUR_EXT )

      PRINT *,' '
      PRINT *,' Fin de l''extraction '
      PRINT *,' '

      IF ( I_CODE_RETOUR_EXT.NE.0 .AND.
     &     I_CODE_RETOUR_EXT.NE.1       ) THEN
        PRINT 101,CDTYPM,I_CODE_RETOUR_EXT
 101    FORMAT(/,' Probleme lors de l''extraction des ',A10,
     &         ' I_CODE_RETOUR_EXT = ',I2,/)
        RETURN
      ENDIF

      IF ( I_NB_MESS.EQ.KNBMESS ) KPLEIN = I_NB_MESS
      IF ( NINIT.EQ.1 ) RETURN

!-----------------------------------------------------------------------

!  Traitements
!  -----------

! 1476 valeurs pour 1 message ( 324 AIRS, 15 AMSU-A et 4 HSB )
        
      BOUCLE_MESSAGE: DO JO=1,I_NB_MESS
        IF ( LCUTOFF .AND. 
     &       CL_DONNEES(1,JO)(1:14).GT.CDATFIN(4) ) CYCLE BOUCLE_MESSAGE
        INBEXTOT = INBEXTOT + 1

        IRLN    = NABSO
        IOTP    = NABSO
        IOCH    = NABSO
        ZLAT    = RABSO
        ZLON    = RABSO
        IDAT    = NABSO
        IETM    = NABSO
        ZALT    = RABSO
        INLV    = NABSO
        IRFL    = 11111
        ISTD    = 0
        CLINDIC = " '        ' "
        CLLAT   = '            '
        CLLON   = '            '
        ICQLAT  = 1
        ICQLON  = 1
        ICQDAT  = 1
        ICQETM  = 1
        ICQALT  = 1
!        IVNM_1  = NABSO
!        ZPOB_1  = RABSO
!        ZPRL_1  = RABSO
!        ZVAR_1  = RABSO
!        IFLG_1  = NABSO
!        IVNM_2  = NABSO
!        ZPOB_2  = RABSO
!        ZPRL_2  = RABSO
!        ZVAR_2  = RABSO
!        IFLG_2  = NABSO
        IVNM_3  = NABSO
        ZPOB_3  = RABSO
        ZPRL_3  = RABSO
        ZVAR_3  = RABSO
        IFLG_3  = NABSO

!  Saisie de la locomotive

        IF ( Z_DONNEES(16,JO).EQ.RABSI .OR. Z_DONNEES(17,JO).EQ.RABSI ) 
     &    CYCLE BOUCLE_MESSAGE
        IOTP = NSATEM
        ZLAT = Z_DONNEES(16,JO)
        ZLON = Z_DONNEES(17,JO)
        WRITE (CLLAT(2:11),'(F10.5)') ZLAT
        WRITE (CLLON(2:11),'(F10.5)') ZLON
        ICODPRO = NINT(Z_DONNEES(3,JO))
        IF ( ICODPRO.NE.160 ) CYCLE BOUCLE_MESSAGE

        CALL OULAN_CAROBS(IOTP,CDTYPM,ICODPRO,IZERO,IZERO,ZLAT,IOCH)

        IDAT = NINT( Z_DONNEES(10,JO) ) * 10000  +
     &         NINT( Z_DONNEES(11,JO) ) * 100    +
     &         NINT( Z_DONNEES(12,JO) )
        IETM = NINT( Z_DONNEES(13,JO) ) * 10000  +
     &         NINT( Z_DONNEES(14,JO) ) * 100    +
     &         FLOOR( Z_DONNEES(15,JO) )

        IF ( Z_DONNEES(2,JO).NE.RABSI ) THEN
          IINDIC = NINT( Z_DONNEES(2,JO) )
          WRITE (CLINDIC(8:10),'(I3.3)') IINDIC
          ILPREND = 0
          DO JSAT=1,MNBSATSEL(N_AIRSBT)
            IF ( IINDIC.EQ.MNOSATSEL(N_AIRSBT,JSAT) ) ILPREND = 1
          ENDDO
          IF ( ILPREND.EQ.0 ) THEN
            ILYEST = 0
            DO JSAT=1,I_NB_SAT_OUT
              IF ( CLINDIC(8:10).EQ.CLSATOUT(JSAT) ) ILYEST = JSAT
            ENDDO
            IF ( ILYEST.EQ.0 ) THEN
              I_NB_SAT_OUT = I_NB_SAT_OUT + 1
              IF ( I_NB_SAT_OUT.LE.10 ) THEN
                CLSATOUT(I_NB_SAT_OUT)  = CLINDIC(8:10)
                INBSATOUT(I_NB_SAT_OUT) = 1
              ENDIF
            ELSE IF ( ILYEST.LE.10 ) THEN
              INBSATOUT(ILYEST) = INBSATOUT(ILYEST) + 1
            ENDIF
            CYCLE BOUCLE_MESSAGE
          ENDIF
          ILENVE = 0
          DO JNST=1,INUMST
            IF ( IINDIC.EQ.INOSAT(JNST) ) ILENVE = JNST
          ENDDO
          IF ( ILENVE.EQ.0 ) THEN
            INUMST = INUMST + 1
            ILENVE = INUMST
            INOSAT(INUMST) = IINDIC
          ENDIF
        ELSE
          CYCLE BOUCLE_MESSAGE
        ENDIF

        IF ( Z_DONNEES(8,JO).NE.RABSI )
     &    ISTD = INT(Z_DONNEES(8,JO)+REPSILON)

!  Saisie des wagons

!   sondeur HSB
!  =============
        IF ( L_AIRSBT_HSB ) THEN

!  informations auxiliaires pour sondeur HSB
!  -----------------------------------------

! info 1  POB etendue de la couche nuageuse
!         PRL numero de l'orbite
!         VAR numero de la ligne de balayage
!         FLG numero du paquet principal

          IVNM_3(1) = NVNUMB(59)
          IF (Z_DONNEES(1375,JO).NE.RABSI) ZPOB_3(1)=Z_DONNEES(1375,JO)  
          IF (Z_DONNEES(  18,JO).NE.RABSI) ZPRL_3(1)=Z_DONNEES(  18,JO)  
          IF (Z_DONNEES(  19,JO).NE.RABSI) ZVAR_3(1)=Z_DONNEES(  19,JO)
          IF (Z_DONNEES(  20,JO).NE.RABSI)
     &      IFLG_3(1) = NINT( Z_DONNEES(20,JO) )

! info 2  POB hauteur de la station
!         PRL distance zenithale solaire
!         VAR azimut du soleil
!         FLG instrument satellitaire (pour le sondeur AIRS)

          IVNM_3(2) = NVNUMB(59)
          IF ( Z_DONNEES(21,JO).NE.RABSI ) ZPOB_3(2) = Z_DONNEES(21,JO)
          IF ( Z_DONNEES(22,JO).NE.RABSI ) ZPRL_3(2) = Z_DONNEES(22,JO)
          IF ( Z_DONNEES(23,JO).NE.RABSI ) ZVAR_3(2) = Z_DONNEES(23,JO)
          IF ( Z_DONNEES(42,JO).NE.RABSI ) 
     &      IFLG_3(2) = NINT( Z_DONNEES(42,JO) )

! info 3  POB distance zenithale du satellite
!         PRL direction ou azimuth
!         VAR numero ou champ de vision
!         FLG nombre de replication de la temperature

          IVNM_3(3) = NVNUMB(59)
          IF ( Z_DONNEES(43,JO).NE.RABSI ) ZPOB_3(3) = Z_DONNEES(43,JO)
          IF ( Z_DONNEES(44,JO).NE.RABSI ) ZPRL_3(3) = Z_DONNEES(44,JO)
          IF ( Z_DONNEES(45,JO).NE.RABSI ) ZVAR_3(3) = Z_DONNEES(45,JO)
          IF ( Z_DONNEES(46,JO).NE.RABSI ) 
     &      IFLG_3(3) = NINT( Z_DONNEES(46,JO) )

          INBP_3 = 3

          BOUCLE_TB_HSB: DO JTB=1,4
            ID = 46 + (JTB-1)*4
            IF ( Z_DONNEES(ID+4,JO).NE.RABSI ) THEN
              INBP_3          = INBP_3 + 1
              IVNM_3(INBP_3) = NVNUMB(50)
              ZPOB_3(INBP_3) = Z_DONNEES(ID+1,JO)
              ZPRL_3(INBP_3) = Z_DONNEES(ID+2,JO)
              ZVAR_3(INBP_3) = Z_DONNEES(ID+4,JO)
              IFLG_3(INBP_3) = 0
              ICQFL          = NINT(Z_DONNEES(ID+3,JO))
              I_MISS         = KBITLU(ICQFL,23,1)
              IF ( ICQFL.EQ.0 ) THEN
                IFLG_3(INBP_3) = KBITEC(IFLG_3(INBP_3),ICQUN,2)
              ELSE IF ( I_MISS.EQ.1 ) THEN
                IFLG_3(INBP_3) = KBITEC(IFLG_3(INBP_3),ICQUN,1)
              ELSE
                DO JBPCQ=1,16
                  ICQAIRS        = KBITLU(ICQFL,JBPCQ,1)
                  IFLG_3(INBP_3) = 
     &              KBITEC(IFLG_3(INBP_3),JBPCQ+2,ICQAIRS)
                ENDDO
                IFLG_3(INBP_3) = KBITEC(IFLG_3(INBP_3),4,20)
              ENDIF
            ENDIF
          ENDDO BOUCLE_TB_HSB

          INLV = INBP_3
          IRLN = NCILET + INLV*NCILBO

!  Copie de l'observation sur le fichier d'obs.
          IF ( INBP_3.GT.3 ) THEN
            INBRETOT       = INBRETOT + 1
            INBSAT(ILENVE) = INBSAT(ILENVE) + 1

           write(wagon,fmt=wagon_prov) INBP_3
	   fmt_final = trim(adjustl(entete))//trim(adjustl(wagon))//")"

          WRITE (NULOBI,fmt_final) IRLN,IOTP,IOCH,ZLAT,ZLON,CLINDIC,
     &                     IDAT,IETM,ZALT,INLV,IRFL,ISTD,
     &                     (IVNM_3(J),ZPOB_3(J),ZPRL_3(J),ZVAR_3(J),
     &                     IFLG_3(J),J=1,INBP_3)
            KNBMECR = KNBMECR + 1
            KNBWAG  = KNBWAG + INBP_3
            IF ( L_GEOPOINTS ) 
     &        WRITE (NULGEO,'(F11.5,F11.5,I5)') ZLON,ZLAT,IINDIC
          ENDIF
        ENDIF

      ENDDO BOUCLE_MESSAGE

!-----------------------------------------------------------------------

      WRITE (NULOUT,301) INBEXTOT,INBRETOT
      DO JNST=1,INUMST
        WRITE (NULOUT,302) INOSAT(JNST),INBSAT(JNST)
      ENDDO
      WRITE (NULOUT,303)
      DO J=1,10
        IF ( INBSATOUT(J).GT.0 )
     &    WRITE (CLNBSATOUT(J),'(I6)') INBSATOUT(J)
      ENDDO
      IF ( I_NB_SAT_OUT.GT.0 ) WRITE (NULOUT,304) CLSATOUT,CLNBSATOUT

 301  FORMAT(/,'     Extraction des donnees AIRSBT ',/,5X,30('-'),//,
     &  ' nombre messages extraits',34x,': ',I6,/,
     &  ' nombre messages retenus',35X,': ',I6,/)
 302  FORMAT(' Satellite :  ',I3,6X,I6,' messages')
 303  FORMAT(/)
 304  FORMAT(/,' Satellites extraits, non retenus : ',10(3X,A3,2X),/,
     &       36X,10(A6,2X))

      RETURN
      END
