      SUBROUTINE EXT_SSMI(KNBMESS,KNBMECR,CDTYPM,KNBWAG,
     &                    PLATN,PLATS,PLONO,PLONE,KNBSAT,KPLEIN)
!-----------------------------------------------------------------------
!  auteur de revision : F. Guillaume
!  date de revision   : 17/03/2008
!  objet              : formats explicites d'ecriture dans OBSOUL
!                       pour mise en conofmite SOPRANO.
!=======================================================================

      IMPLICIT LOGICAL(L)

#include "oulan_pardimo.h"
#include "oulan_yomtomv.h"
#include "oulan_yompin.h"
#include "oulan_yomdirs.h"
#include "oulan_yomnbob.h"
#include "oulan_yomdate.h"
#include "oulan_yomcsts.h"


      PARAMETER ( JP_NBX_PAR = 12      , JP_DIM_STRUCT = 84           )
      PARAMETER ( JP_NBX_TB  =  7      )

      CHARACTER  CLLAT            * 12 , CLLON                     * 12
      CHARACTER  CDTYPM           * 10 , CL_NULL                   *  5

      CHARACTER  CL_TYPE_MESS     * 20 , CL_VERS_MESS              * 20
      CHARACTER  CL_MIN_DATE      * 14 , CL_MAX_DATE               * 14
      CHARACTER  CL_LAST_ARRIVED  *  1 , CL_LISTE_PARAM(1)         * 15
      CHARACTER  CL_LISTE_STAT(1) *  4 , CL_AUTORISATION           * 30
      CHARACTER                          CL_DONNEES(5,KNBMESS)     * 80
      CHARACTER  CL_FROM          *  1 , CL_ORDER                *  127
      CHARACTER  CL_BASE          *  1 , CL_WHERE                * 1023
      CHARACTER  CL_MIN_LAT       *  9 , CL_MAX_LAT                *  9
      CHARACTER  CL_MIN_LON       * 10 , CL_MAX_LON                * 10
      INTEGER    I_PAS_DE_TPS , I_NB_PARAM , I_TYPE_SORTIE , I_NBRE_STAT
      INTEGER    I_CQ_BDM(JP_DIM_STRUCT,KNBMESS)
      INTEGER    KNBSAT(4)
      INTEGER    I_CODE_RETOUR_EXT , I_NB_MESS
      REAL       Z_DONNEES(JP_DIM_STRUCT,KNBMESS)

      REAL  DL_MIN_LAT , DL_MAX_LAT
      REAL  DL_MIN_LON , DL_MAX_LON

      CHARACTER CLINDIC*12,CLSATOUT(10)*3,CLNBSATOUT(10)*6
      INTEGER   ICODM(KNBMESS),IVNM(JP_NBX_PAR),IFLG(JP_NBX_PAR)
      INTEGER   INCQ(0:3),INBSATOUT(10)
      REAL      ZPOB(JP_NBX_PAR),ZPRL(JP_NBX_PAR),ZVAR(JP_NBX_PAR)

! ----------------------------------------------------------------------
! code pour realiser des sorties formatees  OBSOUL (SOPRANO)

      character entete * 84, wagon_prov * 34
      character wagon  * 34, fmt_final * 117
! ----------------------------------------------------------------------


#include "oulan_yombitu.h"

! ----------------------------------------------------------------------
! code pour realiser des sorties formatees  OBSOUL (SOPRANO)

      entete = "(I4,1X,I2,1X,I9,1X,F9.5,1X,F10.5,1X,A12,1X,I8,1X,I6,1X"
      entete = trim(adjustl(entete)) // ",ES12.5,1X,I5,1X,I7,1X,I7,1X,"
      wagon_prov = "(I5,'(1X,I3,1X,3(ES12.5,1X),I11)')"                       
! ----------------------------------------------------------------------
      CL_NULL  = 'NULL'//CHAR(0)

      INCQ(0) = 0
      INCQ(1) = 2
      INCQ(2) = 3
      INCQ(3) = 1

      IZERO   = 0
      ICQUN   = 1

      DO J=1,10
        CLNBSATOUT(J) = '      '
        CLSATOUT(J)   = '   '
        INBSATOUT(J)  = 0
      ENDDO

      I_NB_SAT_OUT = 0

!-----------------------------------------------------------------------

!  Initialisations des arguments de la fonction d'extraction
!  ---------------------------------------------------------

      CL_TYPE_MESS( 1:10) = CDTYPM
      CL_TYPE_MESS(11:20) = '          '
      CL_VERS_MESS        = '%                   '
      CL_MIN_DATE         = CDATDEB(2)
      CL_MAX_DATE         = CDATFIN(2)
      CL_AUTORISATION     = 'OPER                          '
      CL_LAST_ARRIVED     = 'Y'
      CL_LISTE_STAT(1)    = 'NULL'
      CL_LISTE_PARAM(1)   = 'NULL           '

      CL_WHERE            = ' '
      CL_FROM             = '?'
      CL_ORDER(1:21)      = ' ORDER BY LLTBUFR_VAL'
      CL_BASE             = 'Y'

      I_PAS_DE_TPS        = 0
      I_NB_PARAM          = 0
      I_TYPE_SORTIE       = 3
      I_NBRE_STAT         = 0
      I_NB_MESS           = KNBMESS

      DL_MIN_LAT          = -90.
      DL_MAX_LAT          =  90.
      DL_MIN_LON          = -180.
      DL_MAX_LON          =  180.

      WRITE(CL_MIN_LAT(1:9),'(F9.5)')  PLATS
      WRITE(CL_MAX_LAT(1:9),'(F9.5)')  PLATN
      WRITE(CL_MIN_LON(1:10),'(F10.5)') PLONO
      WRITE(CL_MAX_LON(1:10),'(F10.5)') PLONE

      CL_DONNEES          = ' '
      Z_DONNEES           = RABSI
      I_CQ_BDM            = NABSI

      KNBMECR = 0
      KPLEIN  = 0

      CL_WHERE(001:044) = 'and ((((+000.00000>=+000.00000 and ((MINLON<'
      CL_WHERE(045:088) = 'MAXLON and MINLON<=+000.00000 and MAXLON>=+0'
      CL_WHERE(089:132) = '00.00000) or (MINLON>MAXLON and (MINLON<=+00'
      CL_WHERE(133:176) = '0.00000 or MAXLON>=+000.00000)))) or (+000.0'
      CL_WHERE(177:220) = '0000<+000.00000 and ((MINLON<=MAXLON and (MI'
      CL_WHERE(221:264) = 'NLON<=+000.00000 or MAXLON>=+000.00000)) or '
      CL_WHERE(265:308) = 'MINLON>MAXLON))) and (MINLAT<=+00.00000 and '
      CL_WHERE(309:352) = 'MAXLAT>=+00.00000)) or MINLON is NULL or MAX'
      CL_WHERE(353:396) = 'LON is NULL or MINLAT is NULL or MAXLAT is N'
      CL_WHERE(397:400) = 'ULL)'

      CL_WHERE(009:018) =CL_MAX_LON(1:10)
      CL_WHERE(021:030) =CL_MIN_LON(1:10)
      CL_WHERE(064:073) =CL_MAX_LON(1:10)
      CL_WHERE(087:096) =CL_MIN_LON(1:10)
      CL_WHERE(130:139) =CL_MAX_LON(1:10)
      CL_WHERE(152:161) =CL_MIN_LON(1:10)
      CL_WHERE(171:180) =CL_MAX_LON(1:10)
      CL_WHERE(182:191) =CL_MIN_LON(1:10)
      CL_WHERE(227:236) =CL_MAX_LON(1:10)
      CL_WHERE(249:258) =CL_MIN_LON(1:10)
      CL_WHERE(295:303) =CL_MAX_LAT(1:9)
      CL_WHERE(317:325) =CL_MIN_LAT(1:9)
      CL_WHERE(401:422) = ' AND LLTBUFR_VAL IN ('''
      ID = 422
      DO J=1,MNBSATSEL(N_SSMI)
        SELECT CASE (MNOSATSEL(N_SSMI,J))
	CASE (246)
	  CL_WHERE(ID+1:ID+2)='13'
	CASE (247)
	  CL_WHERE(ID+1:ID+2)='14'
	CASE (248)
	  CL_WHERE(ID+1:ID+2)='15'
	CASE DEFAULT
	END SELECT
        IF ( J.LT.MNBSATSEL(N_SSMI) ) THEN
          CL_WHERE(ID+3:ID+5) = ''','''
          ID = ID + 5
        ELSE
          CL_WHERE(ID+3:ID+4) = ''')'
        ENDIF
      ENDDO
      IF ( LCUTOFF) THEN
         CL_LAST_ARRIVED = 'N'
         CL_WHERE(ID+6:ID+25)  = ' AND DATE_INSERT < '''
	 CL_WHERE(ID+26:ID+39)= CDATFIN(4)
	 CL_WHERE(ID+40:ID+42) = ''' '
      ENDIF
!-----------------------------------------------------------------------
      
!  Extraction
!  ----------

      PRINT *,' '
      PRINT *,' Extraction des ',CDTYPM
      PRINT *,' '

      CALL RDLLTDOMCLAUSE(
     &  CL_TYPE_MESS    , CL_VERS_MESS    , CL_MIN_DATE  , CL_MAX_DATE ,
     &  CL_AUTORISATION , CL_LAST_ARRIVED , I_PAS_DE_TPS , CL_NULL     ,
     &  I_NB_PARAM      , Z_DONNEES       , CL_DONNEES   , CL_NULL     , 
     &  I_TYPE_SORTIE   , I_NB_MESS       , DL_MIN_LAT   , DL_MAX_LAT  ,
     &  DL_MIN_LON      , DL_MAX_LON      , CL_NULL      , I_NBRE_STAT ,
     &  CL_FROM         , CL_WHERE        , CL_ORDER     , CL_BASE     ,
     &  I_CODE_RETOUR_EXT )

      PRINT *,' '
      PRINT *,' Fin de l''extraction '
      PRINT *,' '

      IF ( I_CODE_RETOUR_EXT.NE.0 .AND.
     &     I_CODE_RETOUR_EXT.NE.1       ) THEN
         PRINT 101,CDTYPM,I_CODE_RETOUR_EXT
 101     FORMAT(/,' Probleme lors de l''extraction des ',A10,
     &          ' I_CODE_RETOUR_EXT = ',I2,/)
         RETURN
      ENDIF

      IF ( I_NB_MESS.EQ.KNBMESS ) KPLEIN = I_NB_MESS
      IF ( NINIT.EQ.1 ) RETURN

!-----------------------------------------------------------------------

!  Traitements
!  -----------
      BOUCLE_MESSAGE: DO JO=1,I_NB_MESS
        IF (Z_DONNEES(17,JO) > PLATN .OR.
     &      Z_DONNEES(17,JO) < PLATS .OR.
     &      Z_DONNEES(18,JO) > PLONE .OR.
     &      Z_DONNEES(18,JO) < PLONO) CYCLE BOUCLE_MESSAGE
        IF ( LSSMIECH ) THEN
          I_NB_MES_PAQ = NINT(Z_DONNEES(1,JO))
          INOL = (JO-1) / I_NB_MES_PAQ
          INOL = MOD( INOL+1 , NSSMISAUT+1 )
          INOC = MOD( JO , NSSMISAUT+1 )
          IF ( INOL*INOC.NE.1 ) CYCLE BOUCLE_MESSAGE
        ENDIF
        IF ( NINT(Z_DONNEES(19,JO)).NE.5 ) CYCLE BOUCLE_MESSAGE
        IRLN    = NABSO
        IOTP    = NABSO
        IOCH    = NABSO
        ZLAT    = RABSO
        ZLON    = RABSO
        IDAT    = NABSO
        IETM    = NABSO
        ZALT    = RABSO
        INLV    = NABSO
        IRFL    = 11111
        ISTD    = 0
        CLINDIC = " '        ' "
        CLLAT   = '            '
        CLLON   = '            '
        ICQLAT  = 1
        ICQLON  = 1
        ICQDAT  = 1
        ICQETM  = 1
        ICQALT  = 1
        DO JA=1,JP_NBX_PAR
          IVNM(JA) = NABSO
          ZPOB(JA) = RABSO
          ZPRL(JA) = RABSO
          ZVAR(JA) = RABSO
          IFLG(JA) = NABSO
        ENDDO

!  Saisie de la locomotive

        IOTP = NSATEM
        ZLAT = Z_DONNEES(17,JO)
        ZLON = Z_DONNEES(18,JO)
        IF ( I_CQ_BDM(17,JO).EQ.2 .OR.
     &       I_CQ_BDM(18,JO).EQ.2 ) CYCLE BOUCLE_MESSAGE
        WRITE (CLLAT(2:11),'(F10.5)') ZLAT
        WRITE (CLLON(2:11),'(F10.5)') ZLON

        CALL OULAN_CAROBS(IOTP,CDTYPM,IZERO,IZERO,IZERO,ZLAT,IOCH)

        IDAT = NINT( Z_DONNEES(11,JO) ) * 10000  +
     &         NINT( Z_DONNEES(12,JO) ) * 100    +
     &         NINT( Z_DONNEES(13,JO) )
        IETM = NINT( Z_DONNEES(14,JO) ) * 10000  +
     &         NINT( Z_DONNEES(15,JO) ) * 100    +
     &         FLOOR( Z_DONNEES(16,JO) )

! identifiant satellite :  F13 --> 246
!                          F14 --> 247
!                          F15 --> 248
! temporairement, F15 est force a 247 pour homogeneite avec le CEPMMT (!!)

        IINDIC = 0
        IF ( Z_DONNEES(2,JO).NE.RABSI ) THEN
          IF ( NINT(Z_DONNEES(2,JO)).EQ.13 ) THEN
            CLINDIC(8:10) = '246'
            KNBSAT(1)     = KNBSAT(1) + 1
            IINDIC        = 246
          ELSE IF ( NINT(Z_DONNEES(2,JO)).EQ.14 ) THEN
            CLINDIC(8:10) = '247'
            KNBSAT(2)     = KNBSAT(2) + 1
            IINDIC        = 247
          ELSE IF ( NINT(Z_DONNEES(2,JO)).EQ.15 ) THEN
            CLINDIC(8:10) = '248'
            KNBSAT(3)     = KNBSAT(3) + 1
            IINDIC        = 248
          ELSE
            CLINDIC(8:10) = '250'
            KNBSAT(4)     = KNBSAT(4) + 1
            IINDIC        = 250
          ENDIF
          ILPREND = 0
          DO JSAT=1,MNBSATSEL(N_SSMI)
            IF ( IINDIC.EQ.MNOSATSEL(N_SSMI,JSAT) ) ILPREND = 1
          ENDDO
          IF ( ILPREND.EQ.0 ) THEN
            ILYEST = 0
            DO JSAT=1,I_NB_SAT_OUT
              IF ( CLINDIC(8:10).EQ.CLSATOUT(JSAT) ) ILYEST = JSAT
            ENDDO
            IF ( ILYEST.EQ.0 ) THEN
              I_NB_SAT_OUT = I_NB_SAT_OUT + 1
              IF ( I_NB_SAT_OUT.LE.10 ) THEN
                CLSATOUT(I_NB_SAT_OUT)  = CLINDIC(8:10)
                INBSATOUT(I_NB_SAT_OUT) = 1
              ENDIF
            ELSE IF ( ILYEST.LE.10 ) THEN
              INBSATOUT(ILYEST) = INBSATOUT(ILYEST) + 1
            ENDIF
            CYCLE BOUCLE_MESSAGE
          ENDIF
        ELSE
          CYCLE BOUCLE_MESSAGE
        ENDIF

        IF ( I_CQ_BDM(17,JO).NE.NABSI )
     &    ICQLAT = INCQ(I_CQ_BDM(17,JO))
        IF ( I_CQ_BDM(18,JO).NE.NABSI )
     &    ICQLON = INCQ(I_CQ_BDM(18,JO))
        IF ( I_CQ_BDM(11,JO).NE.NABSI .AND.
     &       I_CQ_BDM(12,JO).NE.NABSI .AND.
     &       I_CQ_BDM(13,JO).NE.NABSI )
     &     ICQDAT = MAX0( INCQ(I_CQ_BDM(11,JO)) ,
     &                    MAX0( INCQ(I_CQ_BDM(12,JO)) ,
     &                          INCQ(I_CQ_BDM(13,JO)) ) )
        IF ( I_CQ_BDM(14,JO).NE.NABSI .AND.
     &       I_CQ_BDM(15,JO).NE.NABSI .AND.
     &       I_CQ_BDM(16,JO).NE.NABSI )
     &    ICQETM = MAX0( INCQ(I_CQ_BDM(14,JO)) ,
     &                   MAX0( INCQ(I_CQ_BDM(15,JO)) ,
     &                         INCQ(I_CQ_BDM(16,JO)) ) )
        IRFL = ICQALT*10000 + ICQETM*1000 + ICQDAT*100 + ICQLON*10 +
     &         ICQLAT

        IF ( Z_DONNEES(6,JO).NE.RABSI )
     &    ISTD = INT(Z_DONNEES(6,JO)+REPSILON)

!  informations auxiliaires

! info 1  NCMORNO : numero de l'orbite
!         NCMSLNO : numero de la ligne de balayage
!         NCMPNAS : position sur la fauchee

        IVNM(1) = NVNUMB(59)
!       IF ( Z_DONNEES(8,JO).NE.RABSI )
!    &    ZPOB(1) = Z_DONNEES(8,JO)  
!       SENSOR IDENTIFIER
        ZPOB(1) = 6.0
        IF ( Z_DONNEES(9,JO).NE.RABSI )
     &    ZPRL(1) = Z_DONNEES(9,JO)
        IF ( Z_DONNEES(10,JO).NE.RABSI )
     &    ZVAR(1) = Z_DONNEES(10,JO)

! info 2  NCMTOS  : type de surface
!         NCMVSG  : signification verticale
!         NCMZAN  : angle au zenith

        IVNM(2) = NVNUMB(59)
        IF ( Z_DONNEES(19,JO).NE.RABSI )
     &    ZPOB(2) = Z_DONNEES(19,JO)
        IF ( Z_DONNEES(20,JO).NE.RABSI )
     &    ZPRL(2) = Z_DONNEES(20,JO)

! info 3  Missing values to make it identical to ATOVS

        IVNM(3)=IVNM(2)
        ZPOB(3)=RABSO
        ZPRL(3)=RABSO
        ZVAR(3)=RABSO

!  Saisie des wagons

!  composition du code qualite (IFLG) :

!     bits 1 et 2   code qualite coordonnee verticale
!     bits 3 et 4   code qualite parametre mesure
!     bit    12     coordonnee verticale en Pascals

        INBP  = 3
        ICQCV = 3

!  temperatures de brillance

        DO JTB=1,JP_NBX_TB
          IPTB = 20 + JTB
          IF ( Z_DONNEES(IPTB,JO).NE.RABSI .AND.
     &         I_CQ_BDM(IPTB,JO).NE.2            ) THEN
            INBP = INBP + 1
            IVNM(INBP) = NVNUMB(50)
            ZPOB(INBP) = FLOAT(JTB)
            ZPRL(INBP) = RABSO
            ZVAR(INBP) = Z_DONNEES(IPTB,JO)
            ICQPA      = 3
            IF ( I_CQ_BDM(IPTB,JO).NE.NABSI )
     &        ICQPA = I_CQ_BDM(IPTB,JO)
            IFLG(INBP) = 0
            IFLG(INBP) = KBITEC(IFLG(INBP),ICQCV,1)
            IFLG(INBP) = KBITEC(IFLG(INBP),ICQPA,3)
            IFLG(INBP) = KBITEC(IFLG(INBP),ICQUN,12)
          ENDIF
        ENDDO

!  preparation des wagons pour le contenu en eau precipitable,
!                              l'intensite du vent de surface,
!                              l'eau liquide nuageuse.

        INLV = INBP
        IRLN = NCILET + INLV*NCILBO

!  Copie de l'observation sur le fichier d'obs.

!  For clear sky radiances, consider SSMI as ATOVS
        IOCH=210
        IF ( INBP.GT.2 ) THEN

          write(wagon,fmt=wagon_prov) INBP
	  fmt_final = trim(adjustl(entete))//trim(adjustl(wagon))//")"
	  
          WRITE (NULOBI,fmt_final) IRLN,IOTP,IOCH,ZLAT,ZLON,CLINDIC,
     &                     IDAT,IETM,ZALT,INLV,IRFL,ISTD,
     &                     (IVNM(J),ZPOB(J),ZPRL(J),ZVAR(J),
     &                     IFLG(J),J=1,INBP)
          KNBMECR = KNBMECR + 1
          KNBWAG  = KNBWAG + INBP
          IF ( L_GEOPOINTS ) 
     &      WRITE (NULGEO,'(F11.5,F11.5,I5)') ZLON,ZLAT,IINDIC
        ENDIF
      ENDDO BOUCLE_MESSAGE

!-----------------------------------------------------------------------

!  Impressions
!  -----------

      DO J=1,10
        IF ( INBSATOUT(J).GT.0 )
     &    WRITE (CLNBSATOUT(J),'(I6)') INBSATOUT(J)
      ENDDO
      IF ( I_NB_SAT_OUT.GT.0 ) WRITE (NULOUT,201) CLSATOUT,CLNBSATOUT
 201  FORMAT(/,' Satellites extraits, non retenus : ',10(3X,A3,2X),/,
     &       36X,10(A6,2X))
!-----------------------------------------------------------------------

      RETURN
      END
