      SUBROUTINE OULAN_CAROBS(KTYPO,CDTYPM,
     &                        KVAL1,KVAL2,KVAL3,ZVAL,
     &                        KNCMOCH)
!-----------------------------------------------------------------------
!  SP OULAN_CAROBS : initialisation du descripteur du message (NCMOCH)
!  ---------------   en fonction du type de message
!  Auteur        : Ph. Caille                                    11/94
!  Modifications :
!    15/06/2006 :F Guillaume : blacklistage des GPSSOL
!-----------------------------------------------------------------------

!  - 0 -  Declaration et initialisations des variables
!         --------------------------------------------

#include "oulan_pardimo.h"
#include "oulan_yomtomv.h"
#include "oulan_yomcsts.h"

      CHARACTER   CDTYPM*10,CLABORT*15

      CLABORT = 'OULAN_CAROBS   '
      KNCMOCH = 0

!--------------------------------------------------------------------

!  - 1 -  Initialisation du code de message
!         ---------------------------------

         IF ( CDTYPM.EQ.'SYNOP     ' ) THEN
            IF ( KVAL1.EQ.0 ) THEN
               KNCMOCH = NATSCD
            ELSE IF ( KVAL1.EQ.1 ) THEN
               KNCMOCH = NSRSCD
            ELSE IF ( KVAL1.EQ.2 ) THEN
               KNCMOCH = NSRSCD
            ELSE
               KNCMOCH = NSRSCD
            ENDIF
         ELSE IF ( CDTYPM.EQ.'SHIP      ' ) THEN
            IF ( KVAL1.EQ.0 ) THEN
               KNCMOCH = NATSHS
            ELSE IF ( KVAL1.EQ.1 ) THEN
               KNCMOCH = NSHSCD
            ELSE IF ( KVAL1.EQ.2 ) THEN
               KNCMOCH = NSHSCD
            ELSE
               KNCMOCH = NSHSCD
            ENDIF
         ELSE IF ( CDTYPM.EQ.'SYNOR     ' ) THEN
            KNCMOCH = NSYRCD
         ELSE IF ( CDTYPM.EQ.'RADOMEH   ' ) THEN
            KNCMOCH = NRADOH
         ELSE IF ( CDTYPM.EQ.'SPEMET    ' ) THEN
            KNCMOCH = NABSI
         ELSE IF ( CDTYPM.EQ.'AIREP     ' ) THEN
            KNCMOCH = NAIRCD
         ELSE IF ( CDTYPM.EQ.'AMDAR     ' ) THEN
            KNCMOCH = NAMDAR
         ELSE IF ( CDTYPM.EQ.'ACAR      ' ) THEN
            KNCMOCH = NACARS
         ELSE IF ( CDTYPM.EQ.'SATOB     ' ) THEN
            KNCMOCH = NSTBCD
         ELSE IF ( CDTYPM.EQ.'SATGEO    ' ) THEN
            KNCMOCH = NSTB86
!         ELSE IF ( CDTYPM.EQ.'GEOWIND   ' ) THEN
!            KNCMOCH = NSTB87
         ELSE IF ( CDTYPM.EQ.'BUOY      ' ) THEN
            KNCMOCH = NDRBCD
         ELSE IF ( CDTYPM.EQ.'BATHY     ' ) THEN
            KNCMOCH = NBATHY
         ELSE IF ( CDTYPM.EQ.'TESAC     ' ) THEN
            KNCMOCH = NTESAC
         ELSE IF ( CDTYPM.EQ.'PSEUTEMP  ' ) THEN
            KNCMOCH = NSIMTE
         ELSE IF ( CDTYPM.EQ.'TEMP      ' ) THEN
            KNCMOCH = NLDTCD
         ELSE IF ( CDTYPM.EQ.'TEMPSHIP  ' ) THEN
            KNCMOCH = NSHTCD
         ELSE IF ( CDTYPM.EQ.'TEMPDROP  ' ) THEN
            KNCMOCH = NTDROP
         ELSE IF ( CDTYPM.EQ.'TEMPMOBIL ' ) THEN
            KNCMOCH = NMBTMP
         ELSE IF ( CDTYPM.EQ.'PILOT     ' ) THEN
            KNCMOCH = NLDPCD
         ELSE IF ( CDTYPM.EQ.'PILOTSHIP ' ) THEN
            KNCMOCH = NSHPCD
         ELSE IF ( CDTYPM.EQ.'PILOTMOBIL' ) THEN
            KNCMOCH = NMBPLT
         ELSE IF ( CDTYPM.EQ.'EUROPROFIL' ) THEN
            KNCMOCH = NEWPCD
         ELSE IF ( CDTYPM.EQ.'PROFILER  ' ) THEN
            KNCMOCH = NWPPCD
         ELSE IF ( CDTYPM.EQ.'SATEM     ' ) THEN
            KNCMOCH = NSTMCD
         ELSE IF ( CDTYPM.EQ.'TOVS120   ' ) THEN
            KNCMOCH = NGTHR1
         ELSE IF ( CDTYPM.EQ.'ATOVS     ' ) THEN
            KNCMOCH = NGTHR1
         ELSE IF ( CDTYPM.EQ.'SSMI      ' ) THEN
            KNCMOCH = NSSMI
         ELSE IF ( CDTYPM.EQ.'SSMICE    ' ) THEN
            KNCMOCH = NSSMI
         ELSE IF ( CDTYPM.EQ.'RADIANCE  ' ) THEN
            KNCMOCH = NRARA1
         ELSE IF ( CDTYPM.EQ.'WAVEOB    ' ) THEN
            KNCMOCH = NABSI
         ELSE IF ( CDTYPM.EQ.'TRACKOB   ' ) THEN
            KNCMOCH = NABSI
         ELSE IF ( CDTYPM.EQ.'METAR     ' ) THEN
            KNCMOCH = NABSI
         ELSE IF ( CDTYPM.EQ.'TAF       ' ) THEN
            KNCMOCH = NABSI
         ELSE IF ( CDTYPM.EQ.'ERS1UWI   ' ) THEN
            KNCMOCH = NSCAT1
!         ELSE IF ( CDTYPM.EQ.'QUIKSCAT  ' ) THEN
!            KNCMOCH = NSCAT5
         ELSE IF ( CDTYPM.EQ.'CYCLONE   ' ) THEN
            KNCMOCH = NTYPHO
         ELSE IF ( CDTYPM.EQ.'TOVSHIRS  ' ) THEN
            KNCMOCH = NGTHRB
         ELSE IF ( CDTYPM.EQ.'TOVSMSU   ' ) THEN
            KNCMOCH = NGTHRB
         ELSE IF ( CDTYPM.EQ.'TOVSAMSUA ' ) THEN
            KNCMOCH = NGTHRB
         ELSE IF ( CDTYPM.EQ.'TOVSAMSUB ' ) THEN
            KNCMOCH = NGTHRB
         ELSE IF ( CDTYPM.EQ.'AIRSBT    ' ) THEN
            KNCMOCH = NGTHRB
         ELSE IF ( CDTYPM.EQ.'GPSSOL    ' ) THEN
	    KNCMOCH = NPGPS + KVAL2 *1000000
         ELSE
            KNCMOCH = NABSI
         ENDIF

!--------------------------------------------------------------------

!  - 2 -  Autres initialisations
!         ----------------------

!----------------------------------------------------------------
         IF ( KTYPO.EQ.NSYNOP .OR. KTYPO.EQ.NDRIBU .OR.
     &        KTYPO.EQ.NTEMP  .OR. KTYPO.EQ.NPILOT      ) THEN
!----------------------------------------------------------------

!  KVAL1 :  0  station automatique
!           1  station dotee de personnel
!           2  station mixte, automatique et dotee de personnel
!           3  information manquante

            KNCMOCH = KNCMOCH + KVAL1*1000

!----------------------------------------------------------------
         ELSE IF ( KTYPO.EQ.NAIREP ) THEN
!----------------------------------------------------------------

!  KVAL1 :  0  systeme de navigation par inertie
!           1  OMEGA
!           7  donne manquante

!  KVAL2 :  3  niveau de vol, observation de routine
!           4  niveau de vol, observation de maximum de vent
!           5  phase ascendante
!           6  phase descendante
!           7  donnee manquante

            KNCMOCH = KNCMOCH + KVAL1*1000 + KVAL2*10000

!----------------------------------------------------------------
         ELSE IF ( CDTYPM.EQ.'SATOB     ' .OR.
     &             CDTYPM.EQ.'SATGEO    ' ) THEN
!----------------------------------------------------------------

!  KVAL1 : code producteur

!           7  Etats Unis
!          34  Tokyo
!         254  EUMETSAT

!  KVAL2 : methode de calcul du vent

!   0 pas d'information
!   1 vent derive du deplacement des nuages observe dans le canal infra-rouge
!   2 vent derive du deplacement des nuages observe dans le canal visible
!   3 vent derive des mouvements observes dans le canal vapeur d'eau
!   4 vent derive des mouvements observes dans plusieurs canaux spectraux combines
!   5 vent derive des mouvements dans le canal vapeur d'eau en ciel clair
!   6 vent derive des mouvements dans le canal de l'ozone
!   7 vent derive du deplacement observe dans le canal vapeur (couverture non precisee)

!  KVAL3 : sous-type de message (uniquement pour les GEOWIND)
!           6  HRV ou HWW
!          87  ELW ou WVW

 !           IF ( CDTYPM.NE.'GEOWIND   ' ) KVAL3 = 0
            KVAL3 = 0

            KNCMOCH = KNCMOCH + KVAL1*1000
     &                        + KVAL2*1000000
     &                        + KVAL3*10000000

!----------------------------------------------------------------
         ELSE IF ( CDTYPM.EQ.'SATEM     ' .OR.
     &             CDTYPM.EQ.'TOVS120   ' .OR.
     &             CDTYPM.EQ.'ATOVS     '      ) THEN
!----------------------------------------------------------------

            KNCMOCH = KNCMOCH + KVAL1*1000
     &                        + KVAL2*10000
     &                        + KVAL3*100000

!----------------------------------------------------------------
         ELSE IF ( CDTYPM.EQ.'TOVSAMSUA ' .OR.
     &             CDTYPM.EQ.'TOVSAMSUB ' .OR.
     &             CDTYPM.EQ.'TOVSHIRS  '      ) THEN
!----------------------------------------------------------------

!  KVAL1 : code producteur

!          74  Bracknell
!          98  CEPMMT
!         211  Lannion
!         254  EUMETSAT

            KNCMOCH = KNCMOCH + KVAL1*1000

!----------------------------------------------------------------
         ELSE IF ( CDTYPM.EQ.'CYCLONE   ' ) THEN
!----------------------------------------------------------------

!  KVAL1 : code producteur

!          25  CRC La Reunion
!          34  Japon
!          52  USA

            KNCMOCH = KNCMOCH + KVAL1*1000

!----------------------------------------------------------------
         ELSE IF ( CDTYPM.EQ.'AIRSBT    ' ) THEN
!----------------------------------------------------------------

!  KVAL1 : code producteur

            KNCMOCH = KNCMOCH + KVAL1*1000

         ENDIF

!-----------------------------------------------------------------------

      RETURN
      END
